# -*- coding: utf-8 -*-
# Filename: ttPlayerSettingUi.py
 
 
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import ConfigParser
import os, sys

class ttPlayerSettingUi(QDialog):
	
	def __init__(self, parent = None, *args):
		QDialog.__init__(self, parent)
		self.setWindowTitle(_('Configure ttPlayer engine'))
		self.setMinimumSize(QSize(260, 50))
		
		mainLayout = QVBoxLayout(None)
		self.option = groupHide(self)
		
		buttonBox = QDialogButtonBox(self)
		okButton = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
		cancelButton = QPushButton(QIcon('./icon/cancel.png'), _('Cancel'))
        	buttonBox.addButton(okButton, QDialogButtonBox.AcceptRole)
        	buttonBox.addButton(cancelButton, QDialogButtonBox.RejectRole)
        	
        	mainLayout.addWidget(self.option)
        	mainLayout.addWidget(buttonBox)
        	self.setLayout(mainLayout)
        	
        	self.p = ConfigParser.ConfigParser()
		self.p.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		self.st = self.p.get('engine', 'ttplayer_network')
		if(self.st == 'ctc'):
			self.option.ctc.setChecked(True)
		else:
			self.option.cuc.setChecked(True)
        	
        	self.connect(buttonBox, SIGNAL('accepted()'), self.acceptAction)
        	self.connect(buttonBox, SIGNAL('rejected()'), self, SLOT('reject()'))
        
        def acceptAction(self):
		if(self.st == 'cuc' and self.option.ctc.isChecked()):
			self.p.set('engine', 'ttplayer_network', 'ctc')
			self.p.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
		elif(self.st == 'ctc' and self.option.cuc.isChecked()):
			self.p.set('engine', 'ttplayer_network', 'cuc')
			self.p.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
		self.accept()
		
class groupHide(QGroupBox):
	
	def __init__(self, parent = None, *args):
        	QGroupBox.__init__(self, parent)
		mainLayout = QVBoxLayout(None)
		self.ctc = QRadioButton(_('China telecom network'), self)
		self.cuc = QRadioButton(_('China unicom network'), self)
		mainLayout.addWidget(self.ctc)
		mainLayout.addWidget(self.cuc)
		self.setLayout(mainLayout)


# test code
def main(args):
	app = QApplication(args)
	win = ttPlayerUi()
	win.show()
	sys.exit(app.exec_())

if(__name__  ==  "__main__"):
	main(sys.argv)