# -*- coding: utf-8 -*-
# Filename: mainGui.py
# Author: Xu Jia (Sanfanling), OutLikeAShoe
# Lisence: GPL-2.0

import chardet
import embedLrc
from PyQt4.QtGui import *
from PyQt4.QtCore import *
import lrcParser
from selectItemLocal import selectItemLocal
from selectItemNet import selectItemNet
from lrcEditor import lrcEditor
from helpBrowser import helpBrowser
from preference import preference
from trackInfo import trackInfo
from advancedSearchNet import advancedSearchNet
from chooseEngine import chooseEngine
import sys, glob, re, os, pickle
from urllib import unquote_plus
from defineThread import *
import ConfigParser
from baseGui import baseGui
from searchLocalLrc import searchLocalLrc


############   main GUI process     ###########

class mainGui(baseGui):
	
	def __init__(self, *args):
        	baseGui.__init__(self, None)
        	
        	optionConfList = args[0]
        	shortcutConfList =args[1]
        	playerOption = args[2]
        	
		self.VERSION = args[3]
		self.AUTHORS = args[4]
		
		#print self.VERSION
		#print self.AUTHORS
		
		(tmpPath, self.saveLrcPath, self.ifDownload, currentHeight, bc, fc, hc, fontInfo,
		self.proxy, self.encoderToWrite, self.searchEngine, self.noLrc, self.includeCancel, 
		self.titleBarInfo, self.completeTag, self.filterLyrics, self.filterRule, self.filterCap,
		self.asTrackName, self.minWidth, self.saveToMediaPath, self.searchMediaPath,
		self.useUslt, lastPos, self.lrcTagType, self.lastShowMode, self.lastIsTop,
		self.rememberShowMode, self.enableTrayIcon, self.trayIconNotify, self.transparency, 
		opacity, self.rememberOpacity, self.trayInfoTime, tmpMultiEngines, self.enableMultiEngines,
		self.transEffect, self.autoEmbed, self.autoEmbedFromLocal, self.autoEmbedFromNet,
		self.editorSyncMode, self.lineMargin, tmpRecursionDepth, self.scrollType, editorState) = optionConfList
		
		self.launchPlayer, self.playerPath, self.autoLaunch = playerOption
		
		self.shortcutsValue = shortcutConfList
		(self.shortCut_fullscreen, self.shortCut_osd, self.shortCut_normal, self.shortCut_horizontal, self.shortCut_insert,
		self.shortCut_cancel, self.shortCut_editor, self.shortCut_save, self.shortCut_delay, self.shortCut_advance,
		self.shortCut_fastbar, self.shortCut_refresh) = map(lambda x: QKeySequence.fromString(x), self.shortcutsValue)
		
		if(self.rememberOpacity == 'yes' and self.transparency == 'yes'):
			self.opacity = opacity
		else:
			self.opacity = 10
		self.setWindowOpacity(self.opacity/10.0)
		
		if(self.proxy == 'no'):
			self.proxy = None
		else:
			self.proxy = {'http': self.proxy}

		if(self.enableTrayIcon == 'yes'):
			self.iconTray.setVisible(True)
		
		if(self.ifDownload == 'yes'):
			self.downloadMenu_yesAction.setChecked(True)
		else:
			self.downloadMenu_noAction.setChecked(True)
		self.downloadMenu_thisAction.setEnabled(False)
		
		px, py = lastPos.split(',')
		self.move(int(px), int(py))
		self.currentFont = QFont()
		self.currentFont.fromString(fontInfo)
		self.setFont(self.currentFont)
		
		self.setMinimumWidth(self.minWidth)
		self.margin = QFontMetrics(self.font()).height()+self.lineMargin
		self.nullNum = QApplication.desktop().height()/self.margin
		if(currentHeight == 0):
			self.lineNum = 3
			self.resize(self.minWidth, 3*self.margin)
		else:
			self.lineNum = currentHeight/self.margin
			self.resize(self.minWidth, currentHeight)

		self.myTimer = QTimeLine()
		self.myTimer.setCurveShape(QTimeLine.LinearCurve)
		self.checktimer = QTimer()
		self.checktimer.setSingleShot(False)
		self.hideMouseTimer = QTimer()# for auto hiding cursor in fullscreen display mode
		self.locale = sys.getfilesystemencoding()# detecting locale
		self.multiEngines = tmpMultiEngines.split(',')[0:-1]
		self.path = tmpPath.split(',')
		self.path = map(lambda x: unicode(x, 'utf8').encode(self.locale),self.path)[0:-1]
		self.recursionDepth = tmpRecursionDepth.split(',')[0:-1]
		self.saveLrcPath = unicode(self.saveLrcPath, 'utf8').encode(self.locale)
		
		self.filterRule = unicode(self.filterRule, 'utf8')
		
		mydb = open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.db'), 'r')# get the strategy data from the database
		u = pickle.Unpickler(mydb)
		self.myData = u.load()
		mydb.close()
		

		self.title = ''
		self.artist = ''
		self.media = ''   #  media file's name, with full path
		self.extInfo = ''
		self.extPath = ''
		self.originalLrc = None   #  the lrc original text, which could be saved directly as local lrc file
		self.fileName = None  # lrc file name with full path
		self.lrcFrom = None   # the value should be net, local, embed, or None, which means there is no lrc contents
		self.mainContents = None  # the contents show in main window, maybe lyrics or information
		self.lrcEncoder = None
		self.totalSeekTime = 0
		
		a = bc.split(',')
		b = fc.split(',')
		c = hc.split(',')
		self.backGroundColor = QColor(int(a[0]), int(a[1]), int(a[2]))
		self.foreGroundColor = QColor(int(b[0]), int(b[1]), int(b[2]))
		self.highLightColor = QColor(int(c[0]), int(c[1]), int(c[2]))
		
		self.winFlags = self.windowFlags()
		self.showMode = 'normal'
		self.topIsChecked = False
		if(self.rememberShowMode == 'yes'):
			if(self.lastShowMode == 'osd'):
				self.displayMenu_osdAction_()
			elif(self.lastShowMode == 'horizontal'):
				self.displayMenu_horizontalAction_()
			#elif(self.lastShowMode == 'fullscreen'):
				#self.displayMenu_fullscreenAction_()
				#self.move(0, 0)
			if(self.lastIsTop == 'yes'):
				self.displayMenu_topAction_(True)
			if(self.transEffect == 'yes'):
				self.displayMenu_transparencyAction_(True)
			else:
				self.displayMenu_transparencyAction_(False)
				#self.transEffect = 'no'
				#self.initColor(self.transEffect, self.backGroundColor, self.foreGroundColor, self.highLightColor)
		else:
			self.transEffect = 'no'
			self.initColor(self.transEffect, self.backGroundColor, self.foreGroundColor, self.highLightColor)
		
		if(self.scrollType == 'jump'):
			self.effectMenu_jumpAction.setChecked(True)
		elif(self.scrollType == 'always'):
			self.effectMenu_alwaysRollAction.setChecked(True)
		else:
			self.effectMenu_rollAction.setChecked(True)
		
		

		self.connect(self.myTimer, SIGNAL("finished()"), self.nextDuration)
		self.connect(self.myTimer, SIGNAL("valueChanged(qreal)"), self.animateEffect_scroll)
		self.connect(self.hideMouseTimer,SIGNAL("timeout()"), self.checkHideMouse)
		self.connect(self.checktimer,SIGNAL("timeout()"), self.checkTime)
		
		self.connect(self.lrcAdjustMenu_delayAction,SIGNAL("triggered()"), self.seekSlow)
		self.connect(self.lrcAdjustMenu_advancedAction,SIGNAL("triggered()"), self.seekFast)
		self.connect(self.lrcAdjustMenu_saveToFileAction,SIGNAL("triggered()"), self.saveToFile)
		
		self.connect(self.playerControlMenu_playorpauseAction,SIGNAL("triggered()"), self.playerControlMenu_playorpause)
		self.connect(self.playerControlMenu_stopAction,SIGNAL("triggered()"), self.playerControlMenu_stop)
		self.connect(self.playerControlMenu_prevAction,SIGNAL("triggered()"), self.playerControlMenu_prev)
		self.connect(self.playerControlMenu_nextAction,SIGNAL("triggered()"), self.playerControlMenu_next)
		
		self.connect(self.colorMenu_backAction,SIGNAL("triggered()"), self.colorMenu_back)
		self.connect(self.colorMenu_foreAction,SIGNAL("triggered()"), self.colorMenu_fore)
		self.connect(self.colorMenu_lightAction,SIGNAL("triggered()"), self.colorMenu_light)
		self.connect(self.colorMenu_defaultAction,SIGNAL("triggered()"), self.colorMenu_default)
		
		self.connect(self.setFontAction,SIGNAL("triggered()"), self.setFontAction_)
		
		self.connect(self.setLineAction,SIGNAL("triggered()"), self.setLineAction_)
		
		self.connect(self.downloadMenu_yesAction,SIGNAL("triggered()"), self.downloadMenu_yesAction_)
		self.connect(self.downloadMenu_noAction,SIGNAL("triggered()"), self.downloadMenu_noAction_)
		self.connect(self.downloadMenu_thisAction,SIGNAL("triggered()"), self.downloadMenu_thisAction_)
		
		self.connect(self.effectMenu_jumpAction, SIGNAL("triggered()"), self.switchEffect_jump)
		self.connect(self.effectMenu_rollAction, SIGNAL("triggered()"), self.switchEffect_roll)
		self.connect(self.effectMenu_alwaysRollAction, SIGNAL("triggered()"), self.switchEffect_alwaysRoll)
		
		self.connect(self.displayMenu_normalAction,SIGNAL("triggered()"),self.displayMenu_normalAction_)
		self.connect(self.displayMenu_fullscreenAction,SIGNAL("triggered()"),self.displayMenu_fullscreenAction_)
		self.connect(self.displayMenu_osdAction,SIGNAL("triggered()"),self.displayMenu_osdAction_)
		self.connect(self.displayMenu_topAction,SIGNAL("triggered(bool)"),self.displayMenu_topAction_)
		self.connect(self.displayMenu_transparencyAction,SIGNAL("triggered(bool)"),self.displayMenu_transparencyAction_)
		self.connect(self.displayMenu_horizontalAction,SIGNAL("triggered(bool)"),self.displayMenu_horizontalAction_)
		
		self.connect(self.openLrcEditorAction,SIGNAL("triggered()"),self.openLrcEditorAction_)
		
		self.connect(self.setSearchEngineAction,SIGNAL("triggered()"), self.setSearchEngineAction_)
		
		self.connect(self.otherFunctionsMenu_searchAction,SIGNAL("triggered()"),self.otherFunctionsMenu_searchAction_)
		self.connect(self.otherFunctionsMenu_searchAdvancedAction,SIGNAL("triggered()"),self.otherFunctionsMenu_searchAdvancedAction_)
		self.connect(self.otherFunctionsMenu_reloadAction,SIGNAL("triggered()"),self.otherFunctionsMenu_reloadAction_)
		self.connect(self.otherFunctionsMenu_cancelAction,SIGNAL("triggered()"),self.otherFunctionsMenu_cancelAction_)
		self.connect(self.otherFunctionsMenu_otherSetting,SIGNAL("triggered()"),self.otherFunctionsMenu_otherSetting_)
		self.connect(self.otherFunctionsMenu_readUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_readUsltAction_)
		self.connect(self.otherFunctionsMenu_insertUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_insertUsltAction_)
		self.connect(self.otherFunctionsMenu_deleteUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_deleteUsltAction_)
		self.connect(self.otherFunctionsMenu_deleteAllUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_deleteAllUsltAction_)
		self.connect(self.trackInfoAction,SIGNAL("triggered()"),self.trackInfoAction_)
		
		self.connect(self.viewHelpAction,SIGNAL("triggered()"),self.viewHelpAction_)
		self.connect(self.aboutAction,SIGNAL("triggered()"),self.aboutAction_)
		self.connect(self.aboutQtAction,SIGNAL("triggered()"),self.aboutQtAction_)
		
		self.connect(self.closeAction,SIGNAL("triggered()"),self.quitWidnow)
		
		self.connect(self.quitShortcut,SIGNAL("activated()"),self.quitWidnow)
		
		self.connect(self.nextTrackShortcut,SIGNAL("activated()"),self.playerControlMenu_next)
		self.connect(self.prevTrackShortcut,SIGNAL("activated()"),self.playerControlMenu_prev)
		self.connect(self.pauseTrackShortcut,SIGNAL("activated()"),self.playerControlMenu_playorpause)
		self.connect(self.stopTrackShortcut,SIGNAL("activated()"),self.playerControlMenu_stop)

	
	def customEvent(self,ev):
		if(ev.type() == QEvent.User+1): # for detecting Amarok's status when app starts up and listening the signal from Amarok
			self.playerSignal = ev.playerSignal 
			self.playerStatus = ev.playerStatus
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			if(self.checktimer.isActive()):
				self.checktimer.stop()
			try:
				if self.downAfterChoose.isRunning():
					self.downAfterChoose.terminate()
			except:
				pass
			try:
				if self.downloadThread.isRunning():
					self.downloadThread.terminate()
			except:
				pass
			try:# if some dialogs exist when changes the track, they need to be shut down, the same as below, for example, the strategy dialog has the information just belongs to current track, it shouldn't be shown when different track starts
				self.chooseItermDialog1.done(-1)
			except:
				pass
			try:
				self.chooseItermDialog2.done(-1)
			except:
				pass
			#try:
				#self.advanceSearchBox.done(-1)
			#except:
				#pass
			try:
				self.relationDialog.done(-1)
			except:
				pass
			try:
				self.playerStatusSyncToEditor()
			except:
				pass
			

			self.initTime()
			self.checktimer.setInterval(2500)
			self.checktimer.start()
			
			if(self.playerStatus == 'pause' and self.playerSignal == 'engineStateChange'):# pause
				self.playerControlMenu_playorpauseAction.setText(_('Play'))
				self.playerControlMenu_playorpauseAction.setIcon(QIcon('./icon/player_play.png'))
				self.setTrayMessage(_('Paused'))
				
			if(self.playerStatus == 'playing' or (self.playerStatus == 'pause' and self.playerSignal == 'startup')):
				if(self.playerStatus == 'pause' and self.playerSignal == 'startup'): #pause
					self.playerControlMenu_playorpauseAction.setText(_('Play'))
					self.playerControlMenu_playorpauseAction.setIcon(QIcon('./icon/player_play.png'))
				else:
					self.playerControlMenu_playorpauseAction.setText(_('Pause'))
					self.playerControlMenu_playorpauseAction.setIcon(QIcon('./icon/player_pause.png'))
				self.playerControlMenu_stopAction.setEnabled(True)
				self.otherFunctionsMenu_searchAction.setEnabled(True)
				self.otherFunctionsMenu_searchAdvancedAction.setEnabled(True)
				self.otherFunctionsMenu_reloadAction.setEnabled(True)
				self.otherFunctionsMenu_readUsltAction.setEnabled(True)
				self.otherFunctionsMenu_deleteUsltAction.setEnabled(True)
				self.otherFunctionsMenu_deleteAllUsltAction.setEnabled(True)
				self.trackInfoAction.setEnabled(True)
				
				try:
					self.title = self.di.getTitle()
					self.title = self.title.encode(self.locale)
				except:
					self.title = ''
				try:
					self.artist = self.di.getArtist()
					self.artist = self.artist.encode(self.locale)
				except:
					self.artist = ''
					
				self.media = unquote_plus(self.di.getMediaFile().replace('file://','').encode(self.locale))
				self.extInfo = os.path.splitext(os.path.basename(self.media))[0]
				self.extPath = os.path.dirname(self.media)
				self.originalLrc = None
				self.fileName = None
				self.lrcFrom = None
				self.mainContents = None
				self.lrcEncoder = None
				
				if(self.saveToMediaPath == 'yes' and self.extPath):
					self.savePath = self.extPath
				else:
					self.savePath = self.saveLrcPath
				
				self.initWindowTitle()
				self.setTrayMessage(_('Now playing: ')+unicode('%s - %s' %(self.artist, self.title), self.locale))
				
				if(self.asTrackName == 'yes'):
					self.nameForSave = self.extInfo+'.lrc'
				else:
					self.nameForSave = ('%s - %s.lrc' %(self.artist, self.title)).translate(None, '<>/\\|:"*?')

				self.downloadMenu_thisAction.setEnabled(False)
				
				if(self.title == '' and self.artist == ''):
					taginfo = 'none'
				elif(self.title != '' and self.artist != ''):
					taginfo = 'sufficient'
				else:
					taginfo = 'not sufficient'
				getlrc, searchnet = self.searchLrcRouter(taginfo)
				if(getlrc):
					self.initEvent()
				else:
					if(searchnet):
						self.searchNet()
					else:
						self.showInfo('<p align="center">'+_('Nothing has been searched')+'</p>')

			if(self.playerStatus == 'stop'):
				self.setTrayMessage(_('Stopped'))
				self.title = ''
				self.artist = ''
				self.media = ''   #  media file's name, with full path
				self.extInfo = ''
				self.extPath = ''
				self.originalLrc = None
				self.fileName = None
				self.lrcFrom = None
				self.mainContents = None
				self.lrcEncoder = None
				self.initWindowTitle()
				self.playerControlMenu_playorpauseAction.setText(_('Play'))
				self.playerControlMenu_playorpauseAction.setIcon(QIcon('./icon/player_play.png'))
				self.playerControlMenu_stopAction.setEnabled(False)
				self.otherFunctionsMenu_searchAction.setEnabled(False)
				self.otherFunctionsMenu_searchAdvancedAction.setEnabled(False)
				self.otherFunctionsMenu_reloadAction.setEnabled(False)
				self.otherFunctionsMenu_readUsltAction.setEnabled(False)
				self.otherFunctionsMenu_deleteUsltAction.setEnabled(False)
				self.otherFunctionsMenu_deleteAllUsltAction.setEnabled(False)
				self.trackInfoAction.setEnabled(False)
				
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>', True)
				#self.showInfo(_('Welcome to lrcShow-X'), True)
					
		elif(ev.type() == QEvent.User+2):# for receiving the lrc from net
			t = ev.timeOut
			r = ev.fromAdvDown
			if(ev.originalLrc and not ev.netEncoder):
				self.lrcEncoder = chardet.detect(ev.originalLrc)['encoding']
				if(self.lrcEncoder == 'GB2312'):
					self.lrcEncoder = 'gb18030'
			else:
				self.lrcEncoder=ev.netEncoder
				
			if(ev.originalLrc):
				self.originalLrc = ev.originalLrc
				self.lrcFrom = 'net'
				self.initEvent(r, False)
			else:
				if(not t):
					self.showInfo('<p align="center">'+_('Nothing has been searched')+'</p>')
				else:
					self.showInfo('<p align="center">'+_('Connection timeout')+'</p>')
					
		if(ev.type() == QEvent.User+3):# when searched more than one lrc from net, especially use the ttplayer engine
			lrcList=ev.alist
			engineReturn=ev.engine
			self.chooseItermDialog1=selectItemNet(self)
			for j in lrcList:
				self.chooseItermDialog1.listBox.insertItem(lrcList.index(j),j[0].decode('utf8')+' - '+j[1].decode('utf8'))
			self.chooseItermDialog1.listBox.setCurrentRow(0)
			result1=self.chooseItermDialog1.exec_()
			if(result1==QDialog.Accepted):
				k=self.chooseItermDialog1.listBox.currentRow()
				url=lrcList[k][2]
				self.downAfterChoose=dacThread(self, url, self.proxy, engineReturn)
				self.downAfterChoose.start()
			elif(result1==QDialog.Rejected):
				self.showInfo('<p align="center">'+_('Nothing has been searched')+'</p>')
	

	def showInfo(self, lf, windowBehavior=False):# to show the necessary info in window, no lrc, Amarok stops, searching and so on
	 	'''
		lf: it should be the information that shows on window
		windowBehavior: if set ture, meas the window wouldn't be under the window behavior settings
		'''
		self.mainContents = lf
		self.myTimer.stop()
		self.myTimer.setCurrentTime(0)
		self.initMainEvent(True)
		self.otherFunctionsMenu_cancelAction.setEnabled(False)
		self.lrcAdjustMenu_delayAction.setEnabled(False)
		self.lrcAdjustMenu_advancedAction.setEnabled(False)
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		self.otherFunctionsMenu_insertUsltAction.setEnabled(False)
		if(self.lineNum == 1 and self.showMode == 'horizontal'):
			pass
		else:
			self.hPos = self.margin*((self.nullNum-self.lineNum)/2)
			self.verticalScrollBar().setValue(self.hPos)
		
		if(not windowBehavior):
			if(self.noLrc=='normal'):
				pass
			elif(self.noLrc=='hide'):
				self.hide()
			elif(self.noLrc=='mini'):
				self.showMinimized()
		
		if(self.editorSyncMode == 'yes'):
			try:
				self.dataSyncToEditor()
			except:
				pass
	
	def setTrayMessage(self, info):
		if(self.trayIconNotify == 'yes' and self.enableTrayIcon == 'yes'):
			self.iconTray.showMessage('lrcShow-X', info, 1, self.trayInfoTime)
	
	def initWindowTitle(self):
		if(self.titleBarInfo == 'yes' and self.playerStatus != 'stop'):
			self.setWindowTitle('%s - %s' %(unicode(self.artist, self.locale), unicode(self.title, self.locale)))
		else:
			self.setWindowTitle('lrcShow-X')
	
	def initEvent(self, fromAdvDown = False, canAutoEmbed = False): # new lrc found, necessary init process
		if(self.noLrc == 'hide' and self.isHidden()):
			if(self.showMode == 'fullscreen'):
				self.show()
				self.showFullScreen()
			else:
				self.show()
		if(self.noLrc == 'mini' and self.isMinimized()):
			if(self.showMode == 'fullscreen'):
				self.showFullScreen()
			else:
				self.showNormal()
		self.totalSeekTime = 0
		self.otherFunctionsMenu_cancelAction.setEnabled(True)
		self.lrcAdjustMenu_delayAction.setEnabled(True)
		self.lrcAdjustMenu_advancedAction.setEnabled(True)
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		self.otherFunctionsMenu_insertUsltAction.setEnabled(True)
		
		self.openLrcEditorAction.setEnabled(True)
		if((self.ifDownload == 'yes' and self.lrcFrom == 'net') or (fromAdvDown and self.lrcFrom == 'net')):
			self.downloadMenu_thisAction_()

		if(self.ifDownload == 'no' and self.lrcFrom == 'net'):
			self.downloadMenu_thisAction.setEnabled(True)
		else:
			self.downloadMenu_thisAction.setEnabled(False)
			
		if(self.lrcFrom != 'net'):
			self.lrcEncoder=chardet.detect(self.originalLrc)['encoding']
			if(self.lrcEncoder == 'GB2312'):
				self.lrcEncoder = 'gb18030'
			elif self.lrcEncoder == None:
				self.lrcEncoder = "utf-8"
		try:
			a=unicode(self.originalLrc, str(self.lrcEncoder), 'ignore')
		except UnicodeDecodeError:
			self.showInfo('<p align="center">'+_('An encoding error occurs when reading local lrc file')+'</p>')
			self.openLrcEditorAction.setEnabled(False)
		else:
			p = lrcParser.lrcParser(a)
			if(self.lineNum == 1 and self.showMode == 'horizontal'):
				self.tag, self.mainContents = p.format(self.lineMargin, self.filterRule, self.filterLyrics, self.filterCap, True)
			else:
				self.tag, self.mainContents = p.format(self.lineMargin, self.filterRule, self.filterLyrics, self.filterCap)
			self.initMainEvent()
			self.goToCurrentPara()

		if(canAutoEmbed and self.autoEmbed == 'yes'):
			self.otherFunctionsMenu_insertUsltAction_(True)
		
		if(self.editorSyncMode == 'yes'):
			try:
				self.dataSyncToEditor()
			except:
				pass
	
	def saveToLocal(self):
		try:
			f = open(os.path.join(self.savePath, self.nameForSave), 'w')
		except:
			self.setTrayMessage(_('Fail in download lrc, please check the permission!'))
		else:
			f.write(unicode(self.originalLrc, self.lrcEncoder).encode(self.encoderToWrite))
			f.close()
			self.setTrayMessage(_('Lrc saved: ')+unicode(self.nameForSave, self.locale))
			self.downloadMenu_thisAction.setEnabled(False)
			self.fileName = os.path.join(self.savePath, self.nameForSave)
			self.lrcFrom = 'local'
			self.lrcEncoder = self.encoderToWrite
	
	def initMainEvent(self, noLrcInfo=False):
		if(self.lineNum == 1 and self.showMode == 'horizontal'):
			if(noLrcInfo):
				#j = '<p align="center">&nbsp;</p>'*((self.nullNum-1)/2)
				#lrcFile = j+self.mainContents+j+'<p align="center">&nbsp;</p>'
				self.setText(self.mainContents)
				self.setAlignment(Qt.AlignCenter)
			else:
				fontInfoClass = QFontMetrics(self.font())
				spacelength = fontInfoClass.width(u' ')

				spaceNum = (self.width()/2)/spacelength
			
				t = self.mainContents.strip().split(u'!@#$')
				self.fragmentLength = map(lambda x: fontInfoClass.width(x), t)
				t = map(lambda x: u'&nbsp;&nbsp;&nbsp;&nbsp;%s&nbsp;&nbsp;&nbsp;&nbsp;' %x, t[1:])
				lrcFile = u'&nbsp;'*spaceNum
				for jj in t:
					lrcFile += jj
				lrcFile = lrcFile+u'&nbsp;'*spaceNum
				self.setHtml(lrcFile)
				self.fixLength = 8*spacelength
		else:
			j =  '<p align="center" style=" margin-top:%dpx; margin-bottom:%dpx; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;">&nbsp;</p>' %(self.lineMargin, self.lineMargin)
			j = j*((self.nullNum-1)/2)
			lrcFile = j+self.mainContents+j+'<p align="center">&nbsp;</p>'
			self.setText(lrcFile)
			self.setAlignment(Qt.AlignCenter)
	
	def goToCurrentPara(self):# to center and highlight the current lineMargin
		self.moveCursor(QTextCursor.Start)
		self.hPos = 0
		self.scrollDistance = 0
		currentTime=int(self.di.getTimePoint())+self.totalSeekTime
		try:
			p = -1
			while True:
				p += 1
				if(self.tag[p] >= currentTime):
					break
		except AttributeError:
			pass
		except:
			if(self.lineNum == 1 and self.showMode == 'horizontal'):
				all = 0
				for i in range(len(self.tag)):
					all += self.fragmentLength[i]
				if(self.scrollType == 'always'):
					self.hPos = len(self.tag)*self.fixLength+all+self.fragmentLength[len(self.tag)]
				else:
					self.hPos = ((len(self.tag))*2-1)*self.fixLength/2+all+self.fragmentLength[len(self.tag)]/2
				self.horizontalScrollBar().setValue(self.hPos)
			else:
				for i in range(len(self.tag)+(self.nullNum-self.lineNum)/2):
					self.moveCursor(QTextCursor.Down)
				self.highLight()
				self.hPos = self.margin*(len(self.tag)-1)
				self.verticalScrollBar().setValue(self.hPos)
			
		else:
			if(self.lineNum == 1 and self.showMode == 'horizontal'):
				all = 0
				for i in range(p):
					all += self.fragmentLength[i]
				if(self.scrollType == 'always'):
					self.hPos = p*self.fixLength+all+self.fragmentLength[p]
				else:
					self.hPos = (p*2-1)*self.fixLength/2+all+self.fragmentLength[p]/2
				self.horizontalScrollBar().setValue(self.hPos)
				self.num = p
				if(self.playerStatus == 'pause'):
					pass
				else:
					self.next_time = self.tag[p]-currentTime
					self.myTimer.setDuration(self.next_time)
					self.myTimer.setCurrentTime(0)
					self.myTimer.start()
				
			else:
				for i in range(p+(self.nullNum-1)/2-1):
					self.moveCursor(QTextCursor.Down)
				self.num = p
				if(self.playerStatus == 'pause'):
					pass
				else:
					self.next_time = self.tag[p]-currentTime
					self.myTimer.setDuration(self.next_time)
					self.myTimer.setCurrentTime(0)
					self.myTimer.start()
				try:
					self.highLight()
					self.hPos = self.margin*(self.num-1+(self.nullNum-self.lineNum)/2)
					self.verticalScrollBar().setValue(self.hPos)
				except:
					pass

	def searchNet(self, fastSearch = False):
		'''
		fastSearch: downLoad method is called when the application need to search the lrc from net, whatever from fast search or advanced search. If this method is called by advanced search, not by multi-search, please set true
		'''
		try:
			if(self.downloadThread.isRunning()):
				self.downloadThread.terminate()
		except:
			pass
		if(self.enableMultiEngines == 'yes' and not fastSearch):
			txt = _('Searching the lrc with multi-search mode...')
			self.showInfo('<p align="center">'+txt+'</p>',True)
			self.advanceSearchBox = advancedSearchNet(self, self.searchEngine, self.artist, self.title, self.locale, self.proxy, self.multiEngines)
			self.advanceSearchBox.searchAction()
			self.connect(self.advanceSearchBox.testButton, SIGNAL("clicked()"), self.advDownLrc)
			result = self.advanceSearchBox.exec_()
			if(result == QDialog.Accepted):
				if(self.advanceSearchBox.download.isChecked()):
					self.advDownLrc(True)
					self.downloadMenu_thisAction.setEnabled(False)
				else:
					self.advDownLrc()
			else:
				try:
					self.advanceSearchBox.downloadThread.terminate()
				except:
					pass
				self.showInfo('<p align="center">'+_('Nothing has been searched')+'</p>')
		else:
			txt = _('Searching the lrc on %s lyrics server...') %self.searchEngine
			self.showInfo('<p align="center">'+txt+'</p>',True)
			self.downloadThread = searchNetThread(self, self.artist, self.title, self.locale, self.proxy, self.searchEngine)
			self.downloadThread.start()

	def searchLrcRouter(self, taginfo):
		if(self.useUslt == 'yes'):
			ok = self.searchEmbed()
			if(ok):
				return True, False
		if(taginfo == 'sufficient' or (taginfo == 'not sufficient' and self.completeTag == 'no')):
			logical = True
		else:
			logical = False

		ok, data = self.searchStrategy()
		if(ok and data):
			if(data == 'FLAG.SKIP_SEARCHLOCAL'):
				return False, logical
			elif(data == 'FLAG.SKIP_SEARCHENGINE'):
				ok1 = self.searchLocal(logical)
				if(ok1):
					return True, False
				else:
					return False, False
			elif(data == 'FLAG.SKIP_ALL'):
				return False, False
			else:
				return True, False
		else:
			ok2 = self.searchLocal(logical)
			if(ok2):
				return True, False
			else:
				return False, logical

	def searchEmbed(self):
		p = embedLrc.embedLrc(self.media)
		lrc = p.detectLrc()
		if(lrc != None):
			self.originalLrc = lrc
			self.lrcFrom = 'embed'
			return True
		else:
			return False
	
	def searchStrategy(self):
		
		data = self.myData.get(os.path.basename(self.media), False)
		if(data != 'FLAG.SKIP_ALL' and data != 'FLAG.SKIP_SEARCHLOCAL' and data != 'FLAG.SKIP_SEARCHENGINE' and data):
			if(os.path.exists(data)):
				self.fileName = data
				f = open(self.fileName)
				self.originalLrc = f.read()
				f.close()
				self.lrcFrom = 'local'
				return True, data
			else:
				del self.myData[os.path.basename(self.media)]
				mydb=open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.db'), 'w')
				pickler=pickle.Pickler(mydb, True)
				pickler.dump(self.myData)
				mydb.close()
				return False, data
		elif(data == 'FLAG.SKIP_SEARCHLOCAL' or data == 'FLAG.SKIP_SEARCHENGINE' or data == 'FLAG.SKIP_ALL'):
			return True, data
		else:
			return False, data

	def searchLocal(self, searchTag = True):
		
		p = searchLocalLrc(searchTag, self.path, self.recursionDepth, self.artist, self.title, self.searchMediaPath, self.extPath, self.extInfo)
		k = p.search()
		if(k):
			if(len(k) == 0):
				return False
			elif(len(k) == 1):
				self.fileName = k[0]
				f = open(self.fileName)
				self.originalLrc = f.read()
				f.close()
				self.lrcFrom = 'local'
				return True
			else:
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>',True)
				self.chooseItermDialog2 = selectItemLocal(self)
				for i in k:
					self.chooseItermDialog2.listBox.insertItem(k.index(i),unicode(i,self.locale))
				self.chooseItermDialog2.listBox.setCurrentRow(0)
				result2 = self.chooseItermDialog2.exec_()
				if(result2 == QDialog.Accepted):
					self.fileName = k[self.chooseItermDialog2.listBox.currentRow()]
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData[os.path.basename(self.media)] = self.fileName
						mydb = open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.db'), 'w')
						pickler = pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					f = open(self.fileName)
					self.originalLrc = f.read()
					f.close()
					self.lrcFrom = 'local'
					return True
				elif(result2 == QDialog.Rejected):
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData[os.path.basename(self.media)] = 'FLAG.SKIP_SEARCHLOCAL'
						mydb = open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.db'), 'w')
						pickler = pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					return False
		else:
			return False
	
	def animateEffect_scroll(self, value):
		if(self.scrollType == 'always'):
			if(self.lineNum == 1 and self.showMode == 'horizontal'):
				self.horizontalScrollBar().setValue(int(self.hPos-(1.0-value)*self.scrollDistance))
			else:
				self.verticalScrollBar().setValue(int(self.hPos-(1.0-value)*self.scrollDistance))
		elif(self.scrollType == 'jump'):
			if(value == 0.0):
				if(self.lineNum == 1 and self.showMode == 'horizontal'):
					self.horizontalScrollBar().setValue(self.hPos)
				else:
					self.verticalScrollBar().setValue(self.hPos)
		elif(self.scrollType == 'smooth'):
			if(self.next_time > 700):
				limit = 700.0/self.next_time
				k = value/limit
				if(value <= limit):
					if(self.lineNum == 1 and self.showMode == 'horizontal'):
						self.horizontalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
					else:
						self.verticalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
			elif(200 < self.next_time <= 700):
				limit = 300.0/self.next_time
				k = value/limit
				if(value <= limit):
					if(self.lineNum == 1 and self.showMode == 'horizontal'):
						self.horizontalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
					else:
						self.verticalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
			else:
				if(value  == 1.0):
					if(self.lineNum == 1 and self.showMode == 'horizontal'):
						self.horizontalScrollBar().setValue(self.hPos)
					else:
						self.verticalScrollBar().setValue(self.hPos)

	def highLight(self):
		if(self.lineNum == 1 and self.showMode == 'horizontal'):
			pass
		else:
			self.moveCursor(QTextCursor.StartOfLine)
        		self.moveCursor(QTextCursor.NextBlock,QTextCursor.KeepAnchor)

	def nextDuration(self):# to scroll the lrc
		self.num += 1
		if(self.num > len(self.tag)):
			return
		elif(self.num < len(self.tag)):
			self.next_time = self.tag[self.num]-self.tag[self.num-1]
			if self.next_time < 0:
				self.next_time = 0
			if(self.lineNum == 1 and self.showMode == 'horizontal'):
				self.scrollDistance = self.fixLength+self.fragmentLength[self.num-1]/2+self.fragmentLength[self.num]/2
			else:
				self.scrollDistance = self.margin
			self.hPos = self.hPos+self.scrollDistance
			self.initAnimateTimer()
		else:
			if(self.lineNum == 1 and self.showMode == 'horizontal'):
				self.scrollDistance = self.fragmentLength[-2]/2+self.fragmentLength[-1]/2+self.fixLength
			else:
				self.scrollDistance = self.margin
			self.hPos = self.hPos+self.scrollDistance
			self.initAnimateTimer()
	
	def initAnimateTimer(self):
		self.highLight()
		self.myTimer.setDuration(self.next_time)
		self.myTimer.setCurrentTime(0)
		self.myTimer.start()

	def initTime(self):
		try:
			if(self.playerStatus == 'playing'):
				time = int(self.di.getTimePoint())
				self.expectedTime = time+2500
			else:
				self.expectedTime = 2500
		except:
			try:
				os.remove(os.path.expanduser('~/.lrcShow-X/lrcShow-X.lock'))
			except:
				pass
			self.quitWidnow()
	
	def checkTime(self):
		#print self.playerStatus
		try:
			time = int(self.di.getTimePoint())
			title = self.di.getTitle()
		except:
			try:
				os.remove(os.path.expanduser('~/.lrcShow-X/lrcShow-X.lock'))
			except:
				pass
			self.quitWidnow()
		if(self.playerStatus == 'playing'):
			try:
				title = title.encode(self.locale)
			except:
				title = ''
			#if((abs(int(time)-self.expectedTime) > 200) and self.title != title):
				#self.otherFunctionsMenu_reloadAction_()
				#return
			if((abs(int(time)-self.expectedTime) > 400) and self.title == title and (self.lrcFrom == 'local' or self.lrcFrom == 'net' or self.lrcFrom == 'embed')):
				self.myTimer.stop()
				self.myTimer.setCurrentTime(0)
				self.goToCurrentPara()
			self.expectedTime = time+2500
		else:
			pass

	##########  block:def lrcAdjustMenu's function  ##########
	
	def seekSlow(self): # adjust function for delay
		if(self.fileName):
			self.lrcAdjustMenu_saveToFileAction.setEnabled(True)
		self.totalSeekTime -= 200
		self.myTimer.stop()
		self.myTimer.setCurrentTime(0)
		self.moveCursor(QTextCursor.Start)
		self.goToCurrentPara()
	
	def seekFast(self): # as above, but opposite
		if(self.fileName):
			self.lrcAdjustMenu_saveToFileAction.setEnabled(True)
		self.totalSeekTime += 200
		self.myTimer.stop()
		self.myTimer.setCurrentTime(0)
		self.moveCursor(QTextCursor.Start)
		self.goToCurrentPara()		
	
	def saveToFile(self):# save the offset into file
		f = open(self.fileName)
		content = unicode(f.read(), self.lrcEncoder).encode('utf8')
		f.close()
		offsetList = re.findall('\[offset:.*\]', content)
		if(len(offsetList) != 0):
			try:
				offsetOld = int(offsetList[0][8:-1])
			except:
				offsetOld = 0
			offsetNew = offsetOld+self.totalSeekTime
			offsetLine = '[offset:%s]' %str(offsetNew)
			content = re.sub('\[offset:.*\]', offsetLine, content)
		else:
			offsetLine = '[offset:%s]\n' %str(self.totalSeekTime)
			content = offsetLine+content
		content = unicode(content, 'utf8').encode(self.encoderToWrite)
		f = open(self.fileName, 'w')
		f.write(content)
		f.close()
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		self.totalSeekTime = 0
		self.lrcEncoder = self.encoderToWrite
		
	##########  block end  ##########
	
	##########  block: def playerControlMenu's function  ##########
	
	def playerControlMenu_playorpause(self):# as function's name
		if(self.playerStatus == 'stop' or self.playerStatus == 'pause'):
			self.di.playFunc()
		else:
			self.di.pauseFunc()
			
	def playerControlMenu_stop(self):# as function's name
		self.di.stopFunc()
	
	def playerControlMenu_prev(self):# as function's name
		self.di.prevFunc()
		
	def playerControlMenu_next(self):# as function's name
		self.di.nextFunc()
		
	##########  block end  ###########
	
	########## block: def colorMenu's function  ##########
	
	def colorMenu_back(self):# as function's name
		l = ConfigParser.ConfigParser()
		l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		rgbColor = QColorDialog.getColor(self.backGroundColor)
		if(rgbColor.isValid()):
			self.backGroundColor = rgbColor
			self.initColor(self.transEffect, self.backGroundColor, self.foreGroundColor, self.highLightColor)
			rgbString = '%s,%s,%s' %(str(rgbColor.red()), str(rgbColor.green()), str(rgbColor.blue()))
			l.set('option', 'backroundcolor', rgbString)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
	
	def colorMenu_fore(self):# as function's name
		l = ConfigParser.ConfigParser()
		l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		rgbColor = QColorDialog.getColor(self.foreGroundColor)
		if(rgbColor.isValid()):
			self.foreGroundColor = rgbColor
			self.initColor(self.transEffect, self.backGroundColor, self.foreGroundColor, self.highLightColor)
			rgbString = '%s,%s,%s' %(str(rgbColor.red()), str(rgbColor.green()), str(rgbColor.blue()))
			l.set('option', 'fontcolor', rgbString)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
	
	def colorMenu_light(self):# as function's name
		l = ConfigParser.ConfigParser()
		l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		rgbColor = QColorDialog.getColor(self.highLightColor)
		if(rgbColor.isValid()):
			self.highLightColor = rgbColor
			self.initColor(self.transEffect, self.backGroundColor, self.foreGroundColor, self.highLightColor)
			rgbString = '%s,%s,%s' %(str(rgbColor.red()), str(rgbColor.green()), str(rgbColor.blue()))
			l.set('option', 'highlightcolor', rgbString)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
	
	def colorMenu_default(self):# as function's name
		l = ConfigParser.ConfigParser()
		l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		self.backGroundColor = QColor(93, 139, 182)
		self.foreGroundColor = QColor(255, 255, 255)
		self.highLightColor = QColor(180, 200, 255)
		self.initColor(self.transEffect, self.backGroundColor, self.foreGroundColor, self.highLightColor)
		l.set('option', 'backroundcolor', '93,139,182')
		l.set('option', 'fontcolor', '255,255,255')
		l.set('option', 'highlightcolor', '180,200,255')
		l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))

	########## block end  ##########
	
	########## block: def setFontAction's fuction ##########
	
	def setFontAction_(self):# as function's name
		font, ok = QFontDialog.getFont(self.currentFont)
		if ok:
			self.currentFont = font
			self.setFont(font)
			self.margin = QFontMetrics(self.font()).height()+self.lineMargin
			self.nullNum = QApplication.desktop().height()/self.margin
			if(self.showMode == 'fullscreen'):
				self.lineNum = QApplication.desktop().height()/self.margin
			self.resize(self.width(), self.lineNum*self.margin)
			
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			if(self.lrcFrom != None):
				self.initMainEvent()
				self.goToCurrentPara()
			else:
				lf = '<p align="center">'+self.toPlainText()+'</p>'
				self.showInfo(lf)
			
			l = ConfigParser.ConfigParser()
			l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
			l.set('option', 'fontinfo', str(font.toString().toUtf8()))
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
			
	
	########## block end  ##########
	
	########## block: def setLineAction's fuction ##########
	
	def setLineAction_(self):# as function's name
		#l = ConfigParser.ConfigParser()
		#l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		num, ok = QInputDialog.getInteger(self, _('Set the show-line'), _('Input an odd number, getting best effect'), 3, 1, 25, 2)

		if(ok and num >= 1 and num <= 25):
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			self.lineNum = num
			self.resize(self.width(), num*self.margin)
			if(self.lrcFrom != None):
				self.initMainEvent()
				self.goToCurrentPara()
			else:
				lf='<p align="center">'+self.toPlainText()+'</p>'
				self.showInfo(lf)
			
			#self.setFixedHeight(self.margin*self.lineNum)
			self.update()
			
			
			
	########## block end  ##########
	
	########## block: def downloadMenu's fuction ##########
	
	def downloadMenu_yesAction_(self):# just change the status of auto downloading, but no downloading action would occur
		if(self.ifDownload != 'yes'):
			l = ConfigParser.ConfigParser()
			l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
			#self.downloadMenu_yesAction.setChecked(True)
			self.ifDownload = 'yes'
			l.set('option', 'download', self.ifDownload)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
	
	def downloadMenu_noAction_(self):
		if(self.ifDownload != 'no'):
			l = ConfigParser.ConfigParser()
			l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
			#self.downloadMenu_noAction.setChecked(True)
			self.ifDownload = 'no'
			l.set('option', 'download', self.ifDownload)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
	
	def downloadMenu_thisAction_(self):# downloading the lrc file from net but has 2 conditions: auto download is shut off and the lrc in window is from net
		try:
			unicode(self.originalLrc, self.lrcEncoder).encode(self.encoderToWrite)
		except UnicodeEncodeError:
			b = QMessageBox(QMessageBox.Critical, _('Encoding error'), _('An error occurs when encoding the fetched lrc, please check your setting'))
			bu = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
			b.addButton(bu, QMessageBox.AcceptRole)
			b.exec_()
		else:
			if(os.path.exists(os.path.join(self.savePath, self.nameForSave))):
				a = QMessageBox(QMessageBox.Question, _('Ask'), _('This file already exists, are you sure to overwrite?'))
				yesButton = QPushButton(QIcon('./icon/ok.png'), _('Yes'))
				a.addButton(yesButton, QMessageBox.YesRole)
				noButton = QPushButton(QIcon('./icon/cancel.png'), _('No'))
				a.addButton(noButton, QMessageBox.NoRole)
				a.exec_()
				if(a.clickedButton() == yesButton):
					self.saveToLocal()
			else:
				self.saveToLocal()
					
	##########  block end (need test) ##########
	
	##########  block: def displayMenu's function  ##########
	
	def displayMenu_normalAction_(self):# normal display mode
		if(self.showMode == 'normal'):
			pass
		else:
			k = self.isVisible()
			self.displayMenu_normalAction.setChecked(True)
			if(self.showMode == 'horizontal'):
				self.showMode = 'normal'
				self.displayMenu_fullscreenAction.setEnabled(True)
				self.displayMenu_osdAction.setEnabled(True)
				self.setLineAction.setEnabled(True)
				self.myTimer.stop()
				self.myTimer.setCurrentTime(0)
				#self.lineNum = self.lineNumBefore
				self.resize(self.width(), self.lineNumBefore*self.margin)
				self.winFlags = Qt.Window
				if(self.topIsChecked):
					self.setWindowFlags(self.winFlags | Qt.WindowStaysOnTopHint)
				else:
					self.setWindowFlags(self.winFlags)
				#self.setMinimumHeight(3*self.margin)
				if(self.lrcFrom != None):
					self.initEvent()
				else:
					lf = '<p align="center">'+self.toPlainText()+'</p>'
					self.showInfo(lf)
				if(k):
					self.show()
				self.update()
			elif(self.showMode == 'osd' ):
				self.showMode = 'normal'
				self.displayMenu_fullscreenAction.setEnabled(True)
				self.displayMenu_horizontalAction.setEnabled(True)
				self.winFlags = Qt.Window
				if(self.topIsChecked):
					self.setWindowFlags(self.winFlags | Qt.WindowStaysOnTopHint)
				else:
					self.setWindowFlags(self.winFlags)
				self.setWindowIcon(QIcon('./icon/lrcShow-X.png'))
				if(k):
					self.show()
				self.update()

			elif(self.showMode == 'fullscreen'):
				self.viewport().setMouseTracking(False)
				if(self.hideMouseTimer.isActive()):
					self.hideMouseTimer.stop()
				if(self.viewport().cursor().shape() != Qt.ArrowCursor):
					self.viewport().setCursor(QCursor(Qt.ArrowCursor))
				
				self.displayMenu_osdAction.setEnabled(True)
				
				self.setLineAction.setEnabled(True)
				self.displayMenu_topAction.setEnabled(True)
				self.displayMenu_horizontalAction.setEnabled(True)
				#self.lineNum = self.lineNumBefore
				self.showMode = 'normal'
				
				self.showNormal()
				self.resize(self.widthBefore, self.lineNumBefore*self.margin)
				self.move(self.posBefore)
				self.myTimer.stop()
				self.myTimer.setCurrentTime(0)
				if(self.lrcFrom != None):
					self.initMainEvent()
					self.goToCurrentPara()
				else:
					lf = '<p align="center">'+self.toPlainText()+'</p>'
					self.showInfo(lf)
				self.update()
	
	def displayMenu_fullscreenAction_(self):# fullscreen display mode, the cursor would be auto hiden
		if(self.showMode == 'fullscreen'):
			pass
		else:
			self.displayMenu_fullscreenAction.setChecked(True)
			self.showMode = 'fullscreen'
			self.displayMenu_osdAction.setEnabled(False)
			self.setLineAction.setEnabled(False)
			self.displayMenu_topAction.setEnabled(False)
			self.displayMenu_horizontalAction.setEnabled(False)
			self.widthBefore = self.size().width()
			self.posBefore = self.pos()
			self.lineNumBefore = self.lineNum
			
			self.showFullScreen()
			
			self.lineNum = QApplication.desktop().height()/self.margin
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)

			if(self.lrcFrom != None):
				self.initMainEvent()
				self.goToCurrentPara()
			else:
				lf='<p align="center">'+self.toPlainText()+'</p>'
				self.showInfo(lf)
			self.viewport().setMouseTracking(True)
			self.currentCursorPos = QPoint(0, 0)
			self.lastCursorPos = QPoint(0, 0)
			self.hideMouseTimer.start(2000)
			self.update()

	
	def displayMenu_osdAction_(self):# osd display mode, no title bar, can't resize the window. pyqt3 version in this mode, must stay on top, pyqt4 may be not
		if(self.showMode == 'osd'):
			pass
		else:
			k = self.isVisible()
			self.displayMenu_osdAction.setChecked(True)
			self.showMode = 'osd'
			self.displayMenu_fullscreenAction.setEnabled(False)
			self.displayMenu_horizontalAction.setEnabled(False)
			self.winFlags = Qt.CustomizeWindowHint
			if(self.topIsChecked):
				self.setWindowFlags(self.winFlags | Qt.WindowStaysOnTopHint)
			else:
				self.setWindowFlags(self.winFlags)
			self.setWindowIcon(QIcon('./icon/lrcShow-X.png'))
			if(k):
				self.show()
			self.update()
	
	def displayMenu_horizontalAction_(self):
		if(self.showMode == 'horizontal'):
			pass
		else:
			k = self.isVisible()
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			self.lineNumBefore = self.lineNum
			self.lineNum = 1
			self.displayMenu_horizontalAction.setChecked(True)
			self.showMode = 'horizontal'
			self.displayMenu_fullscreenAction.setEnabled(False)
			self.displayMenu_osdAction.setEnabled(False)
			self.setLineAction.setEnabled(False)
			self.winFlags = Qt.CustomizeWindowHint
			if(self.topIsChecked):
				self.setWindowFlags(self.winFlags | Qt.WindowStaysOnTopHint)
			else:
				self.setWindowFlags(self.winFlags)
			self.resize(self.width(), self.margin)
			#self.setFixedHeight(self.margin)
			
			if(k):
				self.show()
			if(self.lrcFrom != None):
				self.initEvent()
			else:
				lf = '<p align="center">'+self.toPlainText()+'</p>'
				self.showInfo(lf)
			self.update()
	
	def displayMenu_transparencyAction_(self, e):
		if(e):
			self.transEffect = 'yes'
		else:
			self.transEffect = 'no'
		self.setAttribute(Qt.WA_TranslucentBackground, e)
		self.setAttribute(Qt.WA_NoSystemBackground, e)
		self.displayMenu_transparencyAction.setChecked(e)
		self.initColor(self.transEffect, self.backGroundColor, self.foreGroundColor, self.highLightColor)

	def displayMenu_topAction_(self, e):# special display mode in pyqt4 version
		self.displayMenu_topAction.setChecked(e)
		k = self.isVisible()
		oldPos = self.pos()
		if(e):
			self.setWindowFlags(self.winFlags | Qt.WindowStaysOnTopHint)
			self.topIsChecked = True
		else:
			self.setWindowFlags(self.winFlags)
			self.topIsChecked = False
		self.move(oldPos)
		if(k):
			self.show()

	###########  block end  ##########
	
	###########  block: def display effect  #############
	
	def switchEffect_jump(self):
		if(self.scrollType != 'jump'):
			l = ConfigParser.ConfigParser()
			l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
			self.scrollType = 'jump'
			l.set('option', 'scrolltype', self.scrollType)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			if(self.lrcFrom != None):
				self.initMainEvent()
				self.goToCurrentPara()
			else:
				lf = '<p align="center">'+self.toPlainText()+'</p>'
				self.showInfo(lf)
	
	def switchEffect_roll(self):
		if(self.scrollType != 'smooth'):
			l = ConfigParser.ConfigParser()
			l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
			self.scrollType = 'smooth'
			l.set('option', 'scrolltype', self.scrollType)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			if(self.lrcFrom != None):
				self.initMainEvent()
				self.goToCurrentPara()
			else:
				lf = '<p align="center">'+self.toPlainText()+'</p>'
				self.showInfo(lf)
	
	def switchEffect_alwaysRoll(self):
		if(self.scrollType != 'always'):
			l = ConfigParser.ConfigParser()
			l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
			self.scrollType = 'always'
			l.set('option','scrolltype', self.scrollType)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			if(self.lrcFrom != None):
				self.initMainEvent()
				self.goToCurrentPara()
			else:
				lf = '<p align="center">'+self.toPlainText()+'</p>'
				self.showInfo(lf)
	
	########## block: def openLrcEditorAction's function ##########
	def encodingChange(self):
		self.lrcEncoder = self.encoderToWrite
		
	def getStatusMessage(self, tmpType):
		#_('Location: ')+unicode(self.fileName, self.locale)
		if(tmpType == _('local')):
			m = unicode(self.fileName, self.locale)
		elif(tmpType == _('internet')):
			m = _('unknown')
		elif(tmpType == _('embed')):
			m = unicode(self.media, self.locale)
		else:
			m = _('unknown')
		return _('Location: ')+m+'                   '+_('Type: ')+tmpType
		
	def playerStatusSyncToEditor(self):
		if(self.playerStatus=='pause'):
			self.editBox.playorpauseAction.setIcon(QIcon('./icon/player_play.png'))
			self.editBox.playorpauseAction.setText(_('Play(&P)'))
		elif(self.playerStatus=='playing') :
			self.editBox.playorpauseAction.setIcon(QIcon('./icon/player_pause.png'))
			self.editBox.playorpauseAction.setText(_('Pause(&P)'))
			self.editBox.stopAction.setEnabled(True)
		elif(self.playerStatus=='stop') :
			self.editBox.playorpauseAction.setIcon(QIcon('./icon/player_play.png'))
			self.editBox.playorpauseAction.setText(_('Play(&P)'))
			self.editBox.stopAction.setEnabled(False)
			#self.editBox.downloadAction.setEnabled(False)
	
	def dataSyncToEditor(self):
		if(self.saveToMediaPath == 'yes' and self.extPath):
			tmpSavePath = self.extPath
		else:
			tmpSavePath = self.saveLrcPath
			
		if(self.lrcFrom == 'local'):
			f = open(self.fileName)
			tmpFile = f.read()
			f.close()
			tmpType = _('local')
			tmpSaveTarget = self.fileName
		elif(self.lrcFrom == 'net'):
			tmpFile = self.originalLrc
			tmpType = _('internet')
			tmpSaveTarget = tmpSavePath
		elif(self.lrcFrom == 'embed'):
			tmpFile = self.originalLrc
			tmpType = _('embed')
			tmpSaveTarget = self.media
		else:
			tmpFile = None
			tmpType = _('unknown')
			tmpSaveTarget = tmpSavePath
		
		if(self.playerStatus == 'stop'):
			self.editBox.artist = ''
			self.editBox.title = ''
			self.editBox.nameForSave = ' - .lrc'
			#self.editBox.downloadAction.setEnabled(False)
		else:
			self.editBox.artist = self.artist
			self.editBox.title = self.title
			self.editBox.nameForSave = self.nameForSave
			#self.editBox.downloadAction.setEnabled(True)

		self.editBox.lrcTagType = self.lrcTagType
		self.editBox.asTrackName = self.asTrackName
		self.editBox.proxy = self.proxy
		self.editBox.encoderForSave = self.encoderToWrite
		self.editBox.savePath = tmpSavePath
		self.editBox.saveTarget = tmpSaveTarget
		self.editBox.lrcType = tmpType
		
		try:
			self.editBox.statusBar().removeWidget(self.messageLabel)
		except:
			pass
		
		self.messageLabel = QLabel(self.getStatusMessage(tmpType), None)
		self.editBox.statusBar().addWidget(self.messageLabel)
		
		if(tmpFile):
			coder = self.lrcEncoder
			content = unicode(tmpFile, coder)
		else:
			try:
				content = '[ti:%s]\n[ar:%s]\n[al:]\n[by:%s]\n' % (unicode(self.title, self.locale), unicode(self.artist, self.locale), os.getenv("USER"))
			except AttributeError:
				content = '[ti:]\n[ar:]\n[al:]\n[by:%s]\n' %os.getenv("USER")
		self.editBox.lrcArea.setPlainText(content)
		self.editBox.saveAction.setEnabled(False)
	
	def saveSyncMode(self, bool):
		if(bool):
			self.editorSyncMode = 'yes'
			self.editBox.syncModeAction.setIcon(QIcon('./icon/sync_unlock.png'))
		else:
			self.editorSyncMode = 'no'
			self.editBox.syncModeAction.setIcon(QIcon('./icon/sync_lock.png'))
		l = ConfigParser.ConfigParser()
		l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		l.set('option', 'editorsyncmode', self.editorSyncMode)
		l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
	
	def openLrcEditorAction_(self):# as function's name

		self.editBox = lrcEditor(self, self.locale, self.di, self.shortCut_insert, self.shortCut_cancel, self.editorSyncMode)
		
		self.dataSyncToEditor()
		self.playerStatusSyncToEditor()
		
		self.editBox.connect(self.editBox.syncModeAction, SIGNAL("triggered(bool)"), self.saveSyncMode)
		self.connect(self.editBox.playorpauseAction, SIGNAL("triggered()"), self.playerControlMenu_playorpause)
		self.connect(self.editBox.stopAction, SIGNAL("triggered()"), self.playerControlMenu_stop)
		self.connect(self.editBox.prevAction, SIGNAL("triggered()"), self.playerControlMenu_prev)
		self.connect(self.editBox.nextAction, SIGNAL("triggered()"), self.playerControlMenu_next)
		self.connect(self.editBox.syncManually, SIGNAL("triggered()"), self.dataSyncToEditor)
		self.connect(self.editBox, SIGNAL("changeEncoding()"), self.encodingChange)

		self.editBox.show()
	
	######## block end  ###########
	
	##########  block: def setSearchEngineAction's function  #########

	def setSearchEngineAction_(self):# as function's name
		l = ConfigParser.ConfigParser()
		l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		engineList=QStringList()
		for i in glob.glob('./engines/engine_*.py'):
			i=os.path.basename(i)[7:-3]
			engineList.append(i)
		index=engineList.indexOf(l.get('option','searchengine'))
		
		self.chooseEngineDialog = chooseEngine(self)
		if(self.playerStatus == 'stop'):
			self.chooseEngineDialog.searchNow.setEnabled(False)
		else:
			self.chooseEngineDialog.searchNow.setEnabled(True)
		self.chooseEngineDialog.combo.addItems(engineList)
		self.chooseEngineDialog.combo.setCurrentIndex(index)
		
		result=self.chooseEngineDialog.exec_()
		if(result == QDialog.Accepted):
			engine = self.chooseEngineDialog.combo.currentText()
			self.searchEngine = str(engine.toUtf8())
			l.set('option','searchengine', self.searchEngine)
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))
			if(self.chooseEngineDialog.searchNow.isChecked()):
				self.otherFunctionsMenu_searchAction_()
	
	########## block end  ##########
	
	########## block: def otherFunctionsMenu's function ##########
	
	def otherFunctionsMenu_searchAdvancedAction_(self):
		self.advanceSearchBox = advancedSearchNet(self, self.searchEngine, self.artist, self.title, self.locale, self.proxy, None)
		self.connect(self.advanceSearchBox.testButton,SIGNAL("clicked()"),self.advDownLrc)
		self.connect(self.advanceSearchBox.returnButton,SIGNAL("clicked()"),self.otherFunctionsMenu_reloadAction_)
		result = self.advanceSearchBox.exec_()
		if(result == QDialog.Accepted):
			if(self.advanceSearchBox.download.isChecked()):
				self.advDownLrc(True)
				self.downloadMenu_thisAction.setEnabled(False)
			else:
				self.advDownLrc()
	
	def advDownLrc(self,withDownload=False): 
		txt = _('Searching the lrc on %s lyrics server...') %self.advanceSearchBox.table.item(self.advanceSearchBox.table.currentRow(), 2).text()
		self.showInfo('<p align="center">'+txt+'</p>',True)
		bList = self.advanceSearchBox.currentUrlList[self.advanceSearchBox.currentRow]
		self.downAfterChoose=dacThread(self,bList[0], self.proxy,bList[1], withDownload)
		self.downAfterChoose.start()
	
	def otherFunctionsMenu_searchAction_(self):# force the app to search lrc from net whatever the track has lrc
		#di=dbusInterface(self.player,self.obj1,self.obj2,self.obj3)
		self.title = self.di.getTitle().encode(self.locale)
		self.artist = self.di.getArtist().encode(self.locale)
		self.media = unquote_plus(self.di.getMediaFile().replace('file://','').encode(self.locale))
		self.extInfo = os.path.splitext(os.path.basename(self.media))[0]
		self.extPath = os.path.dirname(self.media)
		if(self.asTrackName == 'yes'):
			self.nameForSave = self.extInfo+'.lrc'
		else:
			self.nameForSave = ('%s - %s.lrc' %(self.artist,self.title)).translate(None, '<>/\\|:"*?')
		self.fileName = None  #maybe needn't
		self.originalLrc = None
		self.downloadMenu_thisAction.setEnabled(False)
		self.searchNet(True)
	
	def otherFunctionsMenu_reloadAction_(self):# re-do the process just like the current track is switched to
		if(self.playerStatus == 'playing'):# when the current track is playing
			self.customEvent(playerEvent('engineStateChange', self.playerStatus))
		elif(self.playerStatus=='pause'):# when the current track is pausing
			if(self.myTimer.state() == 2):
				self.customEvent(playerEvent('engineStateChange', self.playerStatus))
			else:
				self.customEvent(playerEvent('startup', self.playerStatus))
		else:#it could not happen when Amarok in stop status
			pass
			
	
	def otherFunctionsMenu_cancelAction_(self):# let the lrc go hell, if has
		if(self.includeCancel == 'yes'):
			d = False
		else:
			d = True
		self.fileName = None
		self.originalLrc = None
		self.lrcFrom = None
		self.myTimer.stop()
		self.myTimer.setCurrentTime(0)
		self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>',d)
		
	def otherFunctionsMenu_readUsltAction_(self):
		p = embedLrc.embedLrc(self.media)
		lrc = p.detectLrc()
		if(lrc != None):
			self.fileName = None
			self.originalLrc = lrc
			self.myTimer.stop()
			self.myTimer.setCurrentTime(0)
			self.initEvent(False, False)
			self.setTrayMessage(_('Using embedded lrc'))
		else:
			a = QMessageBox(QMessageBox.Information, _('Notice'), _('No lrc in current media file'))
			okButton = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
			a.addButton(okButton, QMessageBox.YesRole)
			a.exec_()
	
	def otherFunctionsMenu_insertUsltAction_(self, fromAutoEmbed = False):
		if(self.originalLrc):
			if(fromAutoEmbed):
				if(self.autoEmbedFromNet == 'yes'):
					lrc=self.originalLrc
					encoding=self.lrcEncoder
				else:
					lrc = None
			else:
				lrc=self.originalLrc
				encoding=self.lrcEncoder

		elif(self.fileName):
			if(fromAutoEmbed):
				if(self.autoEmbedFromLocal == 'yes'):
					ff=open(self.fileName)
					lrc=ff.read()
					ff.close()
					encoding=self.lrcEncoder
				else:
					lrc = None
			else:
				ff=open(self.fileName)
				lrc=ff.read()
				ff.close()
				encoding=self.lrcEncoder
			
		elif(self.lrcFrom == 'embed'):
			lrc = None
			if(not fromAutoEmbed):
				a = QMessageBox(QMessageBox.Information, _('Notice'), _('Lrc in media file is being used'))
				okButton = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
				a.addButton(okButton, QMessageBox.YesRole)
				a.exec_()
			
		else:
			lrc=None
			if(not fromAutoEmbed):
				a = QMessageBox(QMessageBox.Information, _('Notice'), _('No lrc is being used'))
				okButton = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
				a.addButton(okButton, QMessageBox.YesRole)
				a.exec_()
			
		if(lrc):
			p = embedLrc.embedLrc(self.media)
			lrcTmp = p.detectLrc()
			if(fromAutoEmbed and lrcTmp != None ):
				pass
			else:
				lrc=unicode(lrc,encoding).encode('utf8')
				p.insertLrc(self.lrcTagType,lrc)
				self.setTrayMessage(_('Succeed in embedding lrc'))

	def otherFunctionsMenu_deleteUsltAction_(self):
		p = embedLrc.embedLrc(self.media)
		flag = p.deleteLrc(self.lrcTagType)
		if flag:
			self.setTrayMessage(_('Succeed in deleting embedded lrc'))
		else:
			a = QMessageBox(QMessageBox.Information, _('Notice'), _('No lrc in %s tag of current media file') %self.lrcTagType)
			okButton = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
			a.addButton(okButton, QMessageBox.YesRole)
			a.exec_()
	
	def otherFunctionsMenu_deleteAllUsltAction_(self):
		typeList = ['id3v2-uslt', 'apetag', 'lyrics3v2', 'lyrics3v1', 'id3v2-sylt']
		existList = []
		p = embedLrc.embedLrc(self.media)
		for i in typeList:
			flag = p.deleteLrc(i)
			if flag:
				existList.append(i)
		if(len(existList) == 0):
			a = QMessageBox(QMessageBox.Information, _('Notice'), _('No lrc in current media file'))
			okButton = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
			a.addButton(okButton, QMessageBox.YesRole)
			a.exec_()
		else:
			self.setTrayMessage(_('Succeed in deleting all embedded lrcs'))
	
	def otherFunctionsMenu_otherSetting_(self):# configurate the app
		tmpShortcutsValue = self.shortcutsValue[:]
		configItem = (self.minWidth, self.lineMargin, self.trayInfoTime, self.autoEmbed, self.autoEmbedFromLocal,
					self.autoEmbedFromNet, self.noLrc, self.includeCancel, self.transparency, self.rememberOpacity,
					self.titleBarInfo, self.rememberShowMode, self.asTrackName, self.completeTag, self.useUslt,
					self.filterLyrics, self.saveToMediaPath, self.searchMediaPath, self.filterRule, self.path, self.enableMultiEngines,
					self.multiEngines, self.recursionDepth, self.saveLrcPath, self.encoderToWrite, self.lrcTagType, self.proxy,
					self.filterCap, self.enableTrayIcon, self.trayIconNotify, tmpShortcutsValue, self.launchPlayer,self.playerPath,
					self.autoLaunch)
		
		settingDialog = preference(self, configItem)
		settingResult = settingDialog.exec_()
		if(settingResult == QDialog.Accepted):

			l = ConfigParser.ConfigParser()
			l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
			
			if(self.lrcTagType != settingDialog.lrcTagType):
				self.lrcTagType = settingDialog.lrcTagType
				l.set('option', 'lrctagtype', str(self.lrcTagType))
			
			if(self.minWidth != settingDialog.minWidth):
				self.minWidth = settingDialog.minWidth
				self.setMinimumWidth(self.minWidth)
				l.set('option', 'minwidth', str(self.minWidth))
				
			if(self.lineMargin != settingDialog.lineMargin):
				self.lineMargin = settingDialog.lineMargin
				self.margin = QFontMetrics(self.font()).height()+self.lineMargin
				self.nullNum = QApplication.desktop().height()/self.margin
				self.resize(self.width(), self.lineNum*self.margin)
				self.otherFunctionsMenu_reloadAction_()
				l.set('option', 'linemargin', str(self.lineMargin))
			
			if(self.trayInfoTime != settingDialog.trayInfoTime):
				self.trayInfoTime = settingDialog.trayInfoTime
				l.set('option', 'trayinfotime', str(self.trayInfoTime))
				
			if(self.noLrc != settingDialog.noLrc):
				self.noLrc = settingDialog.noLrc
				l.set('option', 'nolrc', self.noLrc)
				
			if(self.transparency != settingDialog.transparency):
				self.transparency = settingDialog.transparency
				if(self.transparency == 'no'):
					self.setWindowOpacity(1.0)
				l.set('option', 'transparency', self.transparency)
				
			if(self.rememberOpacity != settingDialog.rememberOpacity):
				self.rememberOpacity = settingDialog.rememberOpacity
				l.set('option', 'rememberopacity', self.rememberOpacity)
				
			if(self.includeCancel != settingDialog.includeCancel):
				self.includeCancel = settingDialog.includeCancel
				l.set('option', 'includecancel', self.includeCancel)
				
			if(self.asTrackName != settingDialog.asTrackName):
				self.asTrackName = settingDialog.asTrackName
				if(self.asTrackName == 'yes'):
					self.nameForSave = self.extInfo+'.lrc'
				else:
					self.nameForSave = ('%s - %s.lrc' %(self.artist,self.title)).translate(None, '<>/\\|:"*?')
				l.set('option', 'astrackname', self.asTrackName)
				
			if(self.autoEmbedFromLocal != settingDialog.autoEmbedFromLocal):
				self.autoEmbedFromLocal != settingDialog.autoEmbedFromLocal
				l.set('option', 'autoembedfromlocal', self.autoEmbedFromLocal)
				
			if(self.autoEmbedFromNet != settingDialog.autoEmbedFromNet):
				self.autoEmbedFromNet = settingDialog.autoEmbedFromNet
				l.set('option', 'autoembedfromnet', self.autoEmbedFromNet)
				
			if(self.autoEmbed != settingDialog.autoEmbed):
				self.autoEmbed = settingDialog.autoEmbed
				l.set('option', 'autoembed', self.autoEmbed)
				
			if(self.useUslt != settingDialog.useUslt):
				self.useUslt = settingDialog.useUslt
				l.set('option', 'useuslt', self.useUslt)
				
			if(self.titleBarInfo != settingDialog.titleBarInfo):
				self.titleBarInfo = settingDialog.titleBarInfo
				l.set('option', 'titlebarinfo', self.titleBarInfo)
				self.initWindowTitle()
				
			if(self.rememberShowMode != settingDialog.rememberShowMode):
				self.rememberShowMode = settingDialog.rememberShowMode
				l.set('option', 'remembershowmode', self.rememberShowMode)
				
			if(self.completeTag != settingDialog.completeTag):
				self.completeTag = settingDialog.completeTag
				l.set('option', 'completetag', self.completeTag)
				
			if(self.filterLyrics != settingDialog.filterLyrics):
				self.filterLyrics = settingDialog.filterLyrics
				l.set('option', 'filterlyrics', self.filterLyrics)
				
			if(self.filterCap != settingDialog.filterCap):
				self.filterCap = settingDialog.filterCap
				l.set('option', 'filtercap', self.filterCap)
			
			if(self.filterRule != settingDialog.filterRule):
				t = settingDialog.filterRule.toUtf8()
				self.filterRule = unicode(t, 'utf8')
				l.set('option', 'filterrule', str(t))
				
			if(self.saveToMediaPath != settingDialog.saveToMediaPath):
				self.saveToMediaPath = settingDialog.saveToMediaPath
				l.set('option', 'savetomediapath', self.saveToMediaPath)
				
			if(self.searchMediaPath != settingDialog.searchMediaPath):
				self.searchMediaPath = settingDialog.searchMediaPath
				l.set('option', 'searchmediapath', self.searchMediaPath)
				
			if(self.enableTrayIcon != settingDialog.enableTrayIcon):
				self.enableTrayIcon = settingDialog.enableTrayIcon
				if(self.enableTrayIcon == 'yes'):
					if(not self.iconTray.isVisible()):
						self.iconTray.setVisible(True)
				else:
					if(self.isHidden()):
						self.show()
					if(self.iconTray.isVisible()):
						self.iconTray.setVisible(False)
				l.set('option', 'trayicon', self.enableTrayIcon)
				
			if(self.enableMultiEngines != settingDialog.enableMultiEngines):
				self.enableMultiEngines = settingDialog.enableMultiEngines
				l.set('option', 'enablemultiengines', self.enableMultiEngines)
				
			if(self.multiEngines != settingDialog.multiEngines):
				self.multiEngines = settingDialog.multiEngines
				l.set('option', 'multiengines', settingDialog.tmpMultiEngines)

			if(self.trayIconNotify != settingDialog.trayIconNotify):
				self.trayIconNotify = settingDialog.trayIconNotify
				l.set('option', 'trayiconnotify', self.trayIconNotify)
			
			if(self.path != settingDialog.path):
				self.path = settingDialog.path
				l.set('option', 'lrcpath', str(settingDialog.s1))
			
			if(self.recursionDepth != settingDialog.recursionDepth):
				self.recursionDepth = settingDialog.recursionDepth
				l.set('option', 'recursiondepth', str(settingDialog.s3))
			
			if(self.saveLrcPath != settingDialog.saveLrcPath):
				saveLrcPath = settingDialog.saveLrcPath
				l.set('option', 'savelrcpath', str(settingDialog.s2))
			
			if(self.encoderToWrite != settingDialog.encoderToWrite):
				self.encoderToWrite = settingDialog.encoderToWrite
				l.set('option', 'encoder', str(self.encoderToWrite))
			
			if(self.lrcTagType != settingDialog.lrcTagType):
				self.lrcTagType != settingDialog.lrcTagType
				l.set('option', 'lrctagtype', str(self.lrcTagType))
			
			if(self.proxy != settingDialog.proxy):
				self.proxy = settingDialog.proxy
				if(self.proxy == None):
					l.set('option', 'proxy', 'no')
				else:
					l.set('option', 'proxy', str(self.pp))
			
			if(self.launchPlayer != settingDialog.launchPlayer):
				self.launchPlayer = settingDialog.launchPlayer
				l.set('player', 'launchplayer', str(self.launchPlayer))
			
			if(self.autoLaunch != settingDialog.autoLaunch):
				self.autoLaunch = settingDialog.autoLaunch
				l.set('player', 'autolaunch', str(self.autoLaunch))
			
			if(self.playerPath != settingDialog.playerPath):
				self.playerPath = settingDialog.playerPath
				l.set('player', 'playerpath', str(self.playerPath))

			if(self.shortcutsValue != settingDialog.shortcutsValue):
				self.shortcutsValue = settingDialog.shortcutsValue[:]
				shortcutsName = ['fullscreen', 'osd', 'normal', 'insert', 'cancel', 'editor', 'save', 'delay', 'advance', 'fastbar', 'refresh']
				(self.shortCut_fullscreen, self.shortCut_osd, self.shortCut_normal, self.shortCut_insert,
				self.shortCut_cancel, self.shortCut_editor, self.shortCut_save, self.shortCut_delay, self.shortCut_advance,
				self.shortCut_fastbar, self.shortCut_refresh) = map(lambda x: QKeySequence.fromString(x), self.shortcutsValue)
				for i in range(len(shortcutsName)):
					l.set('shortcuts', shortcutsName[i], self.shortcutsValue[i])
				
			l.write(open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w'))

	########## block end  ##########
	
	########## block: def trackInfoAction's function  #########
	
	def trackInfoAction_(self):
		trackInfoDialog = trackInfo(self)
		trackInfoDialog.generalTab.artist.setText(unicode(self.artist, self.locale))
		trackInfoDialog.generalTab.title.setText(unicode(self.title, self.locale))
		trackInfoDialog.generalTab.fileName.setText(unicode(self.media, self.locale))
		if(self.fileName != None):
			trackInfoDialog.generalTab.lrcFile.setText(unicode(self.fileName, self.locale))
			trackInfoDialog.strategyTab.pathLine.setText(unicode(self.fileName, self.locale))
		
		data = self.myData.get(os.path.basename(self.media), False)
		if(data):
			if(data == 'FLAG.SKIP_SEARCHLOCAL'):
				content = _('Do not search local')
				trackInfoDialog.strategyTab.comboBox.setCurrentIndex(1)
			elif(data == 'FLAG.SKIP_SEARCHENGINE'):
				content = _('Do not search internet')
				trackInfoDialog.strategyTab.comboBox.setCurrentIndex(2)
			elif(data == 'FLAG.SKIP_ALL'):
				content = _('Do not search at all')
				trackInfoDialog.strategyTab.comboBox.setCurrentIndex(3)
			else:
				content = unicode(data, self.locale)
				trackInfoDialog.strategyTab.comboBox.setCurrentIndex(4)
		else:
			content = _('No strategy')
			trackInfoDialog.strategyTab.comboBox.setCurrentIndex(0)
		res = trackInfoDialog.exec_()
		
		if(res == QDialog.Accepted):
			if(trackInfoDialog.strategyTab.comboBox.currentIndex() != 0):
				if(trackInfoDialog.strategyTab.comboBox.currentIndex() == 1):
					co = 'FLAG.SKIP_SEARCHLOCAL'
				elif(trackInfoDialog.strategyTab.comboBox.currentIndex() == 2):
					co = 'FLAG.SKIP_SEARCHENGINE'
				elif(trackInfoDialog.strategyTab.comboBox.currentIndex() == 3):
					co = 'FLAG.SKIP_ALL'
				elif(trackInfoDialog.strategyTab.comboBox.currentIndex() == 4):
					co = str(trackInfoDialog.strategyTab.pathLine.text().toLocal8Bit())
				self.myData[os.path.basename(self.media)] = co
				mydb = open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.db'), 'w')
				pickler = pickle.Pickler(mydb, True)
				pickler.dump(self.myData)
				mydb.close()
			else:
				try:
					del self.myData[os.path.basename(self.media)]
				except:
					pass
				else:
					mydb = open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.db'), 'w')
					pickler = pickle.Pickler(mydb,True)
					pickler.dump(self.myData)
					mydb.close()
	########## block end  ##########

	
	########## block: def viewHelpAction's function  #########
	
	def viewHelpAction_(self):# open the build-in help-browser
		hel = helpBrowser(self)
		hel.show()
	
	######### block end  #########
	
	#########  block:def aboutAction's function  #########
	
	def aboutAction_(self):
		b = QMessageBox(self)
		b.setIconPixmap(QPixmap('./icon/lrcShow-X.png'))
		b.setWindowTitle(_('About lrcShow-X'))
		b.setText(_('Version: lrcShow-X-%s\nSummary: General application of media player  for showing lrc\nAuthors: %s\nLicense: GPL-v2.0\nBug report: https://bugs.launchpad.net/lrcshow-x\nTranslator: %s') %(self.VERSION, self.AUTHORS, _('translator_credits')))
		bu = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
		b.addButton(bu, QMessageBox.AcceptRole)
		b.exec_()
		
	######### block end  #########
	
	######### block:def aboutQtAction's function  #######
	
	def aboutQtAction_(self):
		QMessageBox.aboutQt(self, _('About Qt'))
		
		
	######### block end  ######################

	
	############# define shortcut  #########################
	
	def keyPressEvent(self,ev):
		if(ev.key() == self.shortCut_delay and self.lrcAdjustMenu_delayAction.isEnabled()):
			self.seekSlow()
		elif(ev.key() == self.shortCut_advance and self.lrcAdjustMenu_advancedAction.isEnabled()):
			self.seekFast()
		elif(ev.key() == self.shortCut_save and self.lrcAdjustMenu_saveToFileAction.isEnabled()):
			self.saveToFile()
		elif(ev.key() == self.shortCut_fullscreen and self.showMode == 'normal'):
			self.displayMenu_fullscreenAction_()
		elif(ev.key() == self.shortCut_normal and self.showMode != 'normal'):
			self.displayMenu_normalAction_()
		elif(ev.key() == self.shortCut_horizontal and self.showMode == 'normal'):
			self.displayMenu_horizontalAction_()
		elif(ev.key() == self.shortCut_osd and self.showMode == 'normal'):
			self.displayMenu_osdAction_()
		elif(ev.key() == self.shortCut_editor):
			self.openLrcEditorAction_()
		elif(ev.key() == self.shortCut_fastbar):
			if(self.toolMenuBar.isHidden()):
				self.toolMenuBar.show()
			else:
				self.toolMenuBar.hide()
		elif(ev.key() == self.shortCut_refresh):
			self.otherFunctionsMenu_reloadAction_()

	def closeEvent(self,ev):
		if(self.enableTrayIcon == 'no'):
			self.beforeClosed()
			ev.accept()
		else:
			ev.ignore()
			self.hide()
	
	def beforeClosed(self):
		l = ConfigParser.ConfigParser()
		l.read(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'))
		point = self.pos()
		x = point.x()
		y = point.y()
		if(self.topIsChecked):
			r='yes'
		else:
			r='no'
		l.set('option', 'height', self.height())
		l.set('option', 'lastposition', '%s,%s' %(str(x),str(y)))
		l.set('option', 'lastshowmode', self.showMode)
		l.set('option', 'lastistop', r)
		l.set('option', 'scrolltype', self.scrollType)
		l.set('option', 'transeffect', self.transEffect)
		if(self.rememberOpacity == 'yes' and self.transparency == 'yes'):
			l.set('option', 'opacity', str(self.opacity))
		f = open(os.path.expanduser('~/.lrcShow-X/lrcShow-X.conf'), 'w')
		l.write(f)
		f.close()
		try:
			os.remove(os.path.expanduser('~/.lrcShow-X/lrcShow-X.lock'))
		except:
			pass

	def quitWidnow(self):
		self.beforeClosed()
		sys.exit()

	def wheelEvent(self, ev):# disable this event
		if(self.transparency == 'yes' and self.opacity <= 10 and self.opacity >= 1):
			self.opacity = self.opacity+ev.delta()/120
			if(self.opacity > 10):
				self.opacity = 10
			elif(self.opacity < 1):
				self.opacity = 1
			self.setWindowOpacity(self.opacity/10.0)

	def mousePressEvent(self, ev):# to get the coordinates for draging and moving the window
		self.xPos = ev.x()
		self.yPos = ev.y()

	def mouseMoveEvent(self, ev):# draging and moving the window, but in fullscreen display mode, the mouseTracking is True and this event is used to auto hide cursor
		if(self.showMode == 'fullscreen'):
			self.currentCursorPos=ev.pos()
			if(self.viewport().cursor().shape() != Qt.ArrowCursor):
				self.viewport().setCursor(QCursor(Qt.ArrowCursor))
				self.hideMouseTimer.start(2000)
		else:
			if(ev.buttons()==Qt.LeftButton):
				a=ev.x()-self.xPos
				b=ev.y()-self.yPos
				self.move(self.x()+a,self.y()+b)
	
	def dragEnterEvent(self, ev):
		urls = ev.mimeData().urls()
		tmpName = str(urls[0].toLocalFile().toLocal8Bit())
		if(tmpName):
			self.dropFromLocal = True
		else:
			tmpName = str(urls[0].toString())
			self.dropFromLocal = False
		if(len(urls) == 1 and tmpName[-4:] == '.lrc' and self.playerStatus != 'stop'):
			ev.acceptProposedAction()
		else:
			pass
	
	def dropEvent(self, ev):
		if(self.dropFromLocal):
			filename = str(ev.mimeData().urls()[0].toLocalFile().toLocal8Bit())
			self.fileName = filename
			f = open(self.fileName)
			lf = f.read()
			f.close()
			if lf.strip() == "":
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
			else:
				self.originalLrc = lf
				self.lrcFrom = 'local'
				self.myTimer.stop()
				self.myTimer.setCurrentTime(0)
				self.initEvent(False, False)
		else:
			filename = str(ev.mimeData().urls()[0].toString())
			self.showInfo('<p align="center">'+_('Getting the lrc from internet...')+'</p>')
			self.downAfterChoose = dacThread(self, filename, self.proxy, None)
			self.downAfterChoose.start()
	
	def resizeEvent(self, ev):
		QTextEdit.resizeEvent(self, ev)
		if(ev.oldSize().height() == -1 or ev.oldSize().height() == ev.size().height() or self.showMode == 'horizontal' or self.showMode == 'fullscreen' or self.showMode == 'osd'):
			pass
		else:
			ds = ev.size().height() - ev.oldSize().height()
			self.hPos -= ds/2.0
			self.verticalScrollBar().setValue(self.hPos)
			self.lineNum = ev.size().height()/self.margin
	
	def checkHideMouse(self):# this function is used to check if the cursor need to hide when a QTimer object's timeout signal is emit
		if(self.lastCursorPos == self.currentCursorPos):
			self.viewport().setCursor(QCursor(Qt.BlankCursor))
			if(self.hideMouseTimer.isActive()):
				self.hideMouseTimer.stop()
		else:
			self.lastCursorPos = self.currentCursorPos
