# -*- coding: utf-8 -*-
# Filename:  dbusplayer.py

import dbus,os,gobject,sys
from dbus.mainloop.glib import DBusGMainLoop
from players.playerBase import playerBase

class dbusPlayer(playerBase):
	
	def __init__(self,player,*args):
		self.player = player
		self.attached = False
		if not args:
			raise TypeError("you must provide some args")
		elif len(args) == 3 and reduce(lambda x,y:x and type(y) == str,(True,)+args):
			args = (args,)
		elif not reduce(lambda x,y: x and type(y) in (list,tuple) and len(y) == 3,(True,)+args):
			raise TypeError("Wrong args provided: %s" % args)
		if len(args) == 1:
			self.name = args[0][0]
			self.path = args[0][1]
			self.interface = args[0][2]
		else:
			self.name, self.path, self.interface = ([],[],[])
			for i in args:
				self.name.append(i[0])
				self.path.append(i[1])
				self.interface.append(i[2])
		playerBase.__init__(self,player)
	
	def attachToBus(self):
		DBusGMainLoop(set_as_default=True)
		bus=dbus.SessionBus()
		if type(self.name) == type(self.path) == type(self.interface) == str:
			proxy_obj=bus.get_object(self.name,self.path)
			self.iface=dbus.Interface(proxy_obj, self.interface)
		elif type(self.name) == type(self.path) == type(self.interface) == list:
			self.iface = []
			for i in range(len(self.name)):
				proxy_obj = bus.get_object(self.name[i],self.path[i])
				self.iface.append(dbus.Interface(proxy_obj, self.interface[i]))
		mainloop = gobject.MainLoop()
		self.attached = True
	
	def isActive(self):
		if hasattr(self,"process"):
			if type(self.process) == str:
				if os.system("ps -C %s > /dev/null" % self.process) != 0:
					return False
			elif type(self.process) == tuple:
				check = False
				for proc_name in self.process:
					if os.system("ps -C %s > /dev/null" % proc_name) == 0:
						check = True
				if check == False:
					return False
			else:
				return False
		try:
			self.attachToBus()
			return True
		except Exception, e:
			sys.stdout.write(str(e)+'\n')
			return False

