# -*- coding: utf-8 -*-
# Filename:  rhythmbox.py

import commands,os
from urllib import unquote
from playerBase import Status
from dbusplayer import dbusPlayer
import dbus

class rhythmbox(dbusPlayer):
	
	def __init__(self):
		self.process = "rhythmbox"
		dbusPlayer.__init__(self,"rhythmbox","org.gnome.Rhythmbox","/org/gnome/Rhythmbox/Player","org.gnome.Rhythmbox.Player")
		self.iface.connect_to_signal("playingChanged", self.statusChanged)
	
	#TRACK SECTION
	def getTitle(self):
		title = commands.getoutput("rhythmbox-client --no-start --print-playing-format %tt")
		return self.autoDecode(title)
		#return self.iface.trackProperty("Title")
	
	def getArtist(self):
		artist = commands.getoutput("rhythmbox-client --no-start --print-playing-format %ta")
		return self.autoDecode(artist)
		#return self.iface.trackProperty("Artist")
	
	def getTimePoint(self):
		try:
			return self.handleTime(self.iface.getElapsed()*1000)
		except:
			return 0
	
	def getMediaFile(self):
		uri = self.iface.getPlayingUri()
		return unquote(uri).replace("file://","")
	
	#PLAYER SECTION
	def getStatus(self):
		status = self.toStatus(self.iface.getPlaying())
		return status
		
	def playFunc(self):
		#os.system("rhythmbox-client --no-start --play")
		self.iface.playPause(True)
	
	def pauseFunc(self):
		#os.system("rhythmbox-client --no-start --pause")
		self.iface.playPause(False)
	
	def stopFunc(self):
		#os.system("rhythmbox-client --no-start --pause")
		self.iface.playPause(False)
	
	def prevFunc(self):
		self.iface.previous()
	
	def nextFunc(self):
		self.iface.next()
	
	#EVENTS SECTION
	def toStatus(self,status):
		if status == 0 or status == (dbus.Boolean(False),):
			return Status().Paused
		else:
			return Status().Playing
	
	def statusChanged(self,*arg):
		if self.callback != None:
			self.callback(self.toStatus(arg))
