# -*- coding: utf-8 -*-
# Filename: preferenceMultisearch.py
 
from PyQt4.QtCore import *
from PyQt4.QtGui import *


class preferenceMultisearch(QWidget):
	
	def __init__(self, parent = None, *args):
		QWidget.__init__(self, parent)
		
		mainLayout=QVBoxLayout(None)
		mainLayout.setContentsMargins(5, 10, 0, 0)
		
		self.allEngines=QListWidget(self)
		self.allEngines.setFixedWidth(130)
		self.allEngines.setEnabled(False)
		self.userEngines=QListWidget(self)
		self.userEngines.setFixedWidth(130)
		self.userEngines.setEnabled(False)
		layout1=QHBoxLayout(None)
		layout1.setContentsMargins(0, 10, 0, 10)
		layout2=QVBoxLayout(None)
		layout2.setContentsMargins(0, 100, 0, 100)
		self.addButton=QPushButton(self)
		self.addButton.setIcon(QIcon('./icon/go-left.png'))
		self.addButton.setEnabled(False)
		self.removeButton=QPushButton(self)
		self.removeButton.setIcon(QIcon('./icon/go-right.png'))
		self.removeButton.setEnabled(False)
		layout2.addWidget(self.addButton)
		layout2.addWidget(self.removeButton)
		layout3=QVBoxLayout(None)
		layout3.setContentsMargins(0, 0, 0, 200)
		#self.defaultButton=QPushButton('Set default',self)
		self.upButton=QPushButton(self)
		self.upButton.setIcon(QIcon('./icon/go-up.png'))
		self.upButton.setEnabled(False)
		self.downButton=QPushButton(self)
		self.downButton.setIcon(QIcon('./icon/go-down.png'))
		self.downButton.setEnabled(False)
		#layout3.addWidget(self.defaultButton)
		layout3.addWidget(self.upButton)
		layout3.addWidget(self.downButton)
		layout1.addWidget(self.allEngines)
		layout1.addLayout(layout2)
		layout1.addWidget(self.userEngines)
		layout1.addLayout(layout3)
		
		self.multiSearch=QCheckBox(_('Enable multi-search mode'), self)
		
		mainLayout.addWidget(self.multiSearch)
		mainLayout.addLayout(layout1)
		self.setLayout(mainLayout)
		
		self.connect(self.multiSearch, SIGNAL("toggled(bool)"), self.enableMultiSearch)
		self.connect(self.addButton, SIGNAL("clicked()"), self.addEngines)
		self.connect(self.removeButton, SIGNAL("clicked()"), self.removeEngines)
		self.connect(self.allEngines, SIGNAL("itemDoubleClicked(QListWidgetItem *)"), self.addEngines)
		self.connect(self.userEngines, SIGNAL("itemDoubleClicked(QListWidgetItem *)"), self.removeEngines)
		self.connect(self.allEngines, SIGNAL("itemActivated ( QListWidgetItem *)"), self.enableAddButton)
		self.connect(self.userEngines, SIGNAL("itemActivated ( QListWidgetItem *)"), self.enableRemoveButton)
		self.connect(self.upButton, SIGNAL("clicked()"), self.upAction)
		self.connect(self.downButton, SIGNAL("clicked()"), self.downAction)
	
	def upAction(self):
		row = self.userEngines.currentRow()
		text = self.userEngines.currentItem().text()
		self.userEngines.takeItem(row)
		self.userEngines.insertItem(row-1, text)
		self.userEngines.setCurrentRow(row-1)
		self.upDownButton()
	
	def downAction(self):
		row = self.userEngines.currentRow()
		text = self.userEngines.currentItem().text()
		self.userEngines.takeItem(row)
		self.userEngines.insertItem(row+1, text)
		self.userEngines.setCurrentRow(row+1)
		self.upDownButton()
	
	def addEngines(self):
		self.userEngines.addItem(self.allEngines.currentItem().text())
		self.allEngines.takeItem(self.allEngines.currentRow())
		if(self.allEngines.count() == 0):
			self.addButton.setEnabled(False)
	
	def removeEngines(self):
		if(self.userEngines.count() != 1):
			self.allEngines.addItem(self.userEngines.currentItem().text())
			self.userEngines.takeItem(self.userEngines.currentRow())
			if(self.userEngines.count() == 1):
				self.removeButton.setEnabled(False)
			self.upDownButton()
	
	def enableAddButton(self):
		self.userEngines.clearSelection()
		self.addButton.setEnabled(True)
		self.removeButton.setEnabled(False)
		self.upButton.setEnabled(False)
		self.downButton.setEnabled(False)
	
	def enableRemoveButton(self):
		self.allEngines.clearSelection()
		if(self.userEngines.count() == 1):
			self.removeButton.setEnabled(False)
		else:
			self.removeButton.setEnabled(True)
		self.addButton.setEnabled(False)
		self.upDownButton()
	
	def upDownButton(self):
		if(self.userEngines.currentRow() > 0):
			self.upButton.setEnabled(True)
		else:
			self.upButton.setEnabled(False)
		if(self.userEngines.currentRow() < self.userEngines.count()-1):
			self.downButton.setEnabled(True)
		else:
			self.downButton.setEnabled(False)
		
	def enableMultiSearch(self, e):
		self.allEngines.setEnabled(e)
		self.userEngines.setEnabled(e)
		if(e == False):
			self.addButton.setEnabled(e)
			self.removeButton.setEnabled(e)
			self.upButton.setEnabled(e)
			self.downButton.setEnabled(e)
			self.allEngines.clearSelection()
			self.userEngines.clearSelection()